#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <unistd.h>
#include <iostream>
#include <vector>
#include <queue>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"


int ja;   // ktory hrac som
Mapa mapa;
Stav stav;
Tah mojTah;


// skratka. pouzivajte v zistiTah().
#define vykonaj(p) vykonajPrikaz(mapa, stav, mojTah, (p))

template<class T> unsigned najdiXy(const vector<T>& v, int x, int y) {
  for (unsigned i = 0; i < v.size(); i++) if (v[i].x == x && v[i].y == y) return i;
  return v.size();
}

const int INF = 2000000047;
const int chcemHrdinov = 2;

int pocetHrdinov = 0;
int pocetPonuk = 0;

int ktorymSmerom(const int x, const int y,const int cielX,const int cielY){
    cerr << "robim BFS(smer)  " << x << "," << y << "\t->\t" << cielX << "," << cielY << endl;
    
    // z polohy (x,y) na polohu (cielX, cielY)
    // ak uz je tu, tak -1
    int bfs_mapa[mapa.w][mapa.h];
    for(int i = 0; i < mapa.w; ++i) for(int j = 0; j < mapa.h; ++j) bfs_mapa[i][j] = INF;
    bfs_mapa[cielX][cielY] = 0;
    queue<int> Q;
    Q.push(cielX); Q.push(cielY);
    
    while(!Q.empty()){
        int px = Q.front(); Q.pop();
        int py = Q.front(); Q.pop();
        
        for(int k = 0; k < 8; ++k){
            //bool jeTamZivocich = (najdiXy(stav.zivocichy, p.cielX, p.cielY) != stav.zivocichy.size());
            bool jeTamZivocich = (najdiXy(stav.zivocichy, px + DX[k], py + DY[k]) != stav.zivocichy.size());
            //bool jeTamPredmet = (najdiXy(stav.predmety, p.cielX, p.cielY) != stav.predmety.size());
            bool jeTamPredmet = (najdiXy(stav.predmety, px + DX[k], py + DY[k]) != stav.predmety.size());
            if (jeTamZivocich && !(px+DX[k] == x && py+DY[k] == y)) continue;        
            //if (z.nesenyPredmet != -1 && jeTamPredmet) return -1;
            if(jeTamPredmet) continue;
            
            if(mapa.priechodne(px+DX[k], py+DY[k]) && bfs_mapa[px+DX[k]][py+DY[k]] > bfs_mapa[px][py] + 1){
                bfs_mapa[px+DX[k]][py+DY[k]] = bfs_mapa[px][py] + 1;
                Q.push(px+DX[k]); Q.push(py + DY[k]);
            }
        }
    }
    
    if(bfs_mapa[x][y] == INF){ cerr << "koncim BFS\n"; return -1;}
    else{
        int mink = 0, best_dist = INF;
        for(int i = 0; i < 8; ++i){
            if(bfs_mapa[x+DX[i]][y+DY[i]] < best_dist){
                best_dist = bfs_mapa[x+DX[i]][y+DY[i]];
                mink = i;
            }
        }
        cerr << "koncim BFS\n";
        return mink;
    }
}

int dlzkaCesty(const int x, const int y,const int cielX,const int cielY){
    cerr << "robim BFS(dlzka)  " << x << "," << y << "\t->\t" << cielX << "," << cielY << endl;
    // z polohy (x,y) na polohu (cielX, cielY)
    // ak uz je tu, tak -1
    int bfs_mapa[mapa.w][mapa.h];
    for(int i = 0; i < mapa.w; ++i) for(int j = 0; j < mapa.h; ++j) bfs_mapa[i][j] = INF;
    bfs_mapa[cielX][cielY] = 0;
    queue<int> Q;
    Q.push(cielX); Q.push(cielY);
    
    int pocet= 0;
    while(!Q.empty()){
    pocet++;
        int px = Q.front(); Q.pop();
        int py = Q.front(); Q.pop();
        
        for(int k = 0; k < 8; ++k){
            //bool jeTamZivocich = (najdiXy(stav.zivocichy, p.cielX, p.cielY) != stav.zivocichy.size());
            bool jeTamZivocich = (najdiXy(stav.zivocichy, px + DX[k], py + DY[k]) != stav.zivocichy.size());
            //bool jeTamPredmet = (najdiXy(stav.predmety, p.cielX, p.cielY) != stav.predmety.size());
            bool jeTamPredmet = (najdiXy(stav.predmety, px + DX[k], py + DY[k]) != stav.predmety.size());
            if (jeTamZivocich && !(px+DX[k] == x && py+DY[k] == y)) continue;        
            //if (z.nesenyPredmet != -1 && jeTamPredmet) return -1;
            if(jeTamPredmet) continue;
            
            if(mapa.priechodne(px+DX[k], py+DY[k]) && bfs_mapa[px+DX[k]][py+DY[k]] > bfs_mapa[px][py] + 1){
                bfs_mapa[px+DX[k]][py+DY[k]] = bfs_mapa[px][py] + 1;
                Q.push(px+DX[k]); Q.push(py + DY[k]);
            }
        }
    }
    cerr << "pocet bol " << pocet << endl;
    
    /*cerr << "cela mapa\n";
    for(int i = 0; i < mapa.w; ++i){ 
        for(int j = 0; j < mapa.h; ++j) 
            cerr << ((bfs_mapa[i][j] == INF) ? -1 : bfs_mapa[i][j] ) << " "; 
        cerr << endl;
    }*/
    cerr << "na policku " << x << " " << y << " je " << bfs_mapa[x][y] << " a to aj vraciam" << endl;
    
    cerr << "koncim BFS\n";
    return bfs_mapa[x][y];
}

void nahodneZverbuj(){ 
    // ak je dost AP tak vyber nahodne mesto a tam zavolaj nahodny typ ktory este nie je v ponuke a ani v poli
    bool uspech = false;
    vector<pair<int,int> > mesta; 
    for(int i = 0; i < mapa.w; ++i) for(int j = 0; j < mapa.h; ++j) 
        if(mapa.zisti(i,j) == MAPA_MESTO){mesta.push_back(make_pair(i,j));}
    
    while(!uspech && mojTah.ap >= kApVerbuj){
        int fs = rand()%mesta.size();
        uspech = (vykonaj(Prikaz::verbuj(rand()%HRDINA_POCET_TYPOV, mesta[fs].first, mesta[fs].second)));
    }
}

// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
    // (sem patri vas kod)
}

// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
    pocetHrdinov = 0; FOREACH(it, stav.zivocichy) if(it->ktorehoHraca == ja) ++pocetHrdinov;
    cerr << "pocet hrdinov " << pocetHrdinov << endl;
    
    pocetPonuk = 0;   FOREACH(it, stav.pracovnePonuky) if(it->ktorehoHraca == ja) ++pocetPonuk;
    cerr << "pocet ponuk   " << pocetPonuk << endl;
    
    if(pocetHrdinov + pocetPonuk < chcemHrdinov){
        cerr << "moc malo ludi, idem verbovat jedneho nahodne" << endl;
        nahodneZverbuj();
     }
    
    // najprv tych co nieco maju
    FOREACH(it, stav.zivocichy) if(it->ktorehoHraca == ja && it->nesenyPredmet != -1){
        cerr << "som hrdina " << it->id << "(" << it->x << "," << it->y << ") a mam predmet " << it->nesenyPredmet << endl;
        // chce to niekto? c
        // ak ano, tak sa ho pokus odniest
        // ak nie, tak ho pokus vyhodit
        bool je_potrebny = false;
        FOREACH(q, stav.questy) if(q->ziadanyPredmet == it->nesenyPredmet){
            cerr << "hura, chce to mesto " << q->cielX << "," << q->cielY << endl;
            je_potrebny = true;
            bool mozem_sa_hybat = true;
            while(it->nesenyPredmet != -1 && mozem_sa_hybat){
                if((it->x - q->cielX)*(it->x - q->cielX) +  (it->y - q->cielY)*(it->y - q->cielY) == 1){
                    cerr << "toto chce mesto pri ktorom stojim. tak tu vec zhodim" << endl;
                    int cena = zistiApCenu(mapa,stav,mojTah, Prikaz::poloz(it->id, q->cielX, q->cielY));
                    cerr << "stalo by to " << cena << endl;
                    if(vykonaj(Prikaz::poloz(it->id, q->cielX, q->cielY))){
                        cerr << "som polozil" << endl;
                        cerr << "koncim tymto hrdinom" << endl;
                        break;
                    }
                    else{
                        cerr << "ERROR: nepodarilo sa mi to polozit" << endl;
                        cerr << "skusim zautocit" << endl;
                        vykonaj(Prikaz::utoc(it->id, q->cielX, q->cielY));
                    }
                }            
                else{
                    cerr << "este tam treba aj kracat. tak kracam" << endl;
                    int k = ktorymSmerom(it->x,it->y,q->cielX,q->cielY);
                    if(k == -1){
                        cerr << "smola, neda sa dosiahnut" << endl;
                        mozem_sa_hybat = false;
                    }
                    else{
                        cerr << "pokusim sa tam ist" << endl;
                        int cena = zistiApCenu(mapa,stav,mojTah,Prikaz::chod(it->id, it->x + DX[k], it->y + DY[k]));
                        cerr << "stalo by to " << cena << endl;
                        if(cena == -1){
                            cerr << "nemozem tam ist :(" << endl; 
                            mozem_sa_hybat = false;
                        }
                        else if(cena > mojTah.ap){
                            cerr << "uz som vsetko minul :(" << endl;
                            mozem_sa_hybat = false;
                        }
                        else{
                            if((kApZasoba - pocetHrdinov*kApJedlo)/pocetHrdinov >= cena){
                                cerr << "nie je toho vela, mozem skusit :)" << endl;
                                if(vykonaj(Prikaz::chod(it->id, it->x + DX[k], it->y + DY[k]))){
                                    cerr << "som sa pohol" << endl;
                                    //cerr << "koncim tymto hrdinom" << endl;
                                }
                                else{ 
                                    cerr << "nepodarilo sa mi pohnut" << endl;
                                    mozem_sa_hybat = false;
                                }
                            }
                            else{
                                cerr << "je toho trochu vela, ale ja som carovny :P" << endl;
                                mozem_sa_hybat = false;
                            }
                        }
                    }                
                }
            }   
        }
        if(!je_potrebny){
            // ak som stale tu, tak potom moj predmet je mi na nic
            for(int i = 0; i < 8 && it->nesenyPredmet != -1 && mojTah.ap > 0; ++i){
                vykonaj(Prikaz::poloz(it->id, it->x + DX[i], it->y + DY[i]));
            }
            if(it->nesenyPredmet == -1) cerr << "predmet je vyhodeny\n";
            }
    }
    
    //teraz tie, co nemaju nic
    FOREACH(it, stav.zivocichy) if(it->ktorehoHraca == ja && it->nesenyPredmet == -1){
        cerr << "som hrdina " << it->id << " a nemam predmet" << endl;
        int best_dist = INF;
        pair<int,int> best_pos;
        FOREACH(q, stav.questy){
            FOREACH(item, stav.predmety) if(item->typ == q->ziadanyPredmet){
                int curr_dist = dlzkaCesty(it->x, it->y, item->x, item->y);
                cerr << "cur_dist " << curr_dist << endl; 
                if(curr_dist < best_dist){
                    best_dist = curr_dist;
                    best_pos = make_pair(item->x, item->y);
                }    
            }
        } 
        cerr << "najlepsia ponuka " << best_dist << endl;
        cerr << "pos " << best_pos.first << "," << best_pos.second << endl;
        cerr << "pohnut sa tam? :)" << endl;
        
        if(best_dist == INF){ cerr << "nie, nikam nejdem" << endl; continue;}
        bool mozem_sa_hybat = true;
        while(mozem_sa_hybat){
            int k = ktorymSmerom(it->x,it->y,best_pos.first,best_pos.second);
            if(k == -1){
                cerr << "smola, neda sa dosiahnut" << endl;
                mozem_sa_hybat = false;
            }
            else{
                cerr << "pokusim sa tam ist" << endl;
                int cena = zistiApCenu(mapa,stav,mojTah,Prikaz::chod(it->id, it->x + DX[k], it->y + DY[k]));
                cerr << "stalo by to " << cena << endl;
                if(cena == -1){
                    cerr << "nemozem tam ist :(" << endl; 
                    mozem_sa_hybat = false;
                }
                else if(cena > mojTah.ap){
                    cerr << "uz som vsetko minul :(" << endl;
                    mozem_sa_hybat = false;
                }
                else{
                    if((kApZasoba - pocetHrdinov*kApJedlo)/pocetHrdinov >= cena){
                        cerr << "nie je toho vela, mozem skusit :)" << endl;
                        if(vykonaj(Prikaz::chod(it->id, it->x + DX[k], it->y + DY[k]))){
                            cerr << "som sa pohol" << endl;
                            //cerr << "koncim tymto hrdinom" << endl;
                        }
                        else{
                            cerr << "nepodarilo sa mi pohnut" << endl;
                            mozem_sa_hybat = false;
                        }
                    }
                    else{
                        cerr << "je toho trochu vela, ale ja som carovny :P" << endl;
                        mozem_sa_hybat = false;
                    }
                }
            }
        }
    
    } 
    
    // koniec tahu, este to mozem zopakovat
    //if(2*mojTah.ap > kApZasoba) zistiTah();
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  unsigned int seed = time(NULL) * getpid();
  srand(seed);

  nacitaj(cin, ja);
  nacitaj(cin, mapa);
  fprintf(stderr, "START ja=%d, pid=%d, seed=%u\n", ja, getpid(), seed);
  inicializuj();

  while (cin.good()) {
    nacitaj(cin, stav);
    mojTah = zaciatokTahu(stav, ja);
    zistiTah();
    uloz(cout, mojTah.prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

