#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <unistd.h>
#include <iostream>
#include <vector>
#include <queue>
#include <utility>
#include <algorithm>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"

// skratka. pouzivajte v zistiTah().
#define vykonaj(p) vykonajPrikaz(mapa, stav, mojTah, (p))
#define par(a,b) make_pair(a, b)

int A[9]={1,1,1,0,-1,-1,-1,0,0},
    B[9]={1,0,-1,-1,-1,0,1,1,0};

int ja;   // ktory hrac som
Mapa mapa;
Stav stav;
Tah mojTah;

int bfs(int x, int y, int cx, int cy) {
  bool apa[mapa.h][mapa.w];
  for (int i=0; i<mapa.h; i++) {
    for (int j=0; j<mapa.w; j++) {
      apa[i][j]=false;
    }
  }
  apa[y][x]=true;
  queue<pair<pair<int,int>,int> > QQ;
  QQ.push(par(par(x,y),0) );
  while (!QQ.empty()) {
    int X=QQ.front().first.first,
	Y=QQ.front().first.second,
	z=QQ.front().second;
    if ((X==cx)&&(Y==cy)) {
      return z;
    }
    for (int i=0; i<8; i++) {
      if (mapa.priechodne(X+A[i],Y+B[i])) {
	if (!apa[Y+B[i]][X+A[i]]) {
	  apa[Y+B[i]][X+A[i]]=true;
	  QQ.push(par(par(X+A[i],Y+B[i]),z+1) );
	}
      }
    }
    QQ.pop();
  }
  return -1; //z neznameho dovodu to nevyslo
}


double skore(int X, int Y, int H, int nP) {
  double max=0;
  FOREACH (q, stav.questy) {
    double l=0;
    FOREACH (p, stav.predmety) {
      if (q->ziadanyPredmet != p->typ) continue;
      /////////////////////////////////////////
      double vyh = double(99*q->zlato)/double(1 + bfs(X,Y,p->x,p->y) + bfs(p->x,p->y,q->cielX,q->cielY) );
      if (vyh>l) l=vyh; 
    }
    FOREACH (it, stav.zivocichy) {
      if (q->ziadanyPredmet != it->nesenyPredmet) continue;
      if ((H < it->hp)||(it->ktorehoHraca >=0)) continue;
      /////////////////////////////////////////
      double vyh = double(99*q->zlato)/double(1 + bfs(X,Y,it->x,it->y) + bfs(it->x,it->y,q->cielX,q->cielY) );
      if (vyh>l) l=vyh; 
    }
    if (nP==q->ziadanyPredmet) {
      double vyh = double(99*q->zlato)/double(1 + bfs(X,Y,q->cielX,q->cielY) );
      if (vyh>l) l=vyh;
    }
    if (l>max) max=l;
  }
  return max;
}


// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
  // (sem patri vas kod)
}


// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
  // (sem patri vas kod)
  // priklad: if (vykonaj(Prikaz::chod(niekto, x, y))) { /* podarilo sa */ }

  // verbuj hrdinu
  int X, Y;
  do {
    X=rand()%mapa.w;
    Y=rand()%mapa.h;
  } while (mapa.zisti(X,Y) != MAPA_MESTO ) ;
  vykonaj(Prikaz::verbuj(0,X,Y));
  
  bool chcemTah; //chcem Ta
  do {
    chcemTah=false;
    FOREACH (it, stav.zivocichy) {
      if (it->ktorehoHraca != ja) continue;
      /////////////////////////////////////
      int smer=rand()%9;
      double vyhodnost=skore(it->x, it->y, it->hp, it->nesenyPredmet);
      fprintf(stderr, "%f\n", vyhodnost);
      for (int i=0; i<8; i++) {
	if (!mapa.priechodne(it->x+A[i],it->y+B[i])) continue;
	double S=skore(it->x + A[i], it->y + B[i], it->hp, it->nesenyPredmet);
	fprintf(stderr, "%f\n", S);
	if (S>vyhodnost) {
	  smer=i; vyhodnost=S;
	}
      fprintf(stderr, "\n");
      }
      if (vykonaj(Prikaz::chod(it->id,it->x+A[smer],it->y+B[smer])) ) chcemTah=true;
      else if (vykonaj(Prikaz::utoc(it->id,it->x+A[smer],it->y+B[smer])) ) chcemTah=true;
      else if (mapa.zisti(it->x+A[smer],it->y+B[smer])==MAPA_MESTO) {
	vykonaj(Prikaz::poloz(it->id,it->x+A[smer],it->y+B[smer]));
	chcemTah=true;
      }
    }
  } while (chcemTah) ;
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  unsigned int seed = time(NULL) * getpid();
  srand(seed);

  nacitaj(cin, ja);
  nacitaj(cin, mapa);
  fprintf(stderr, "START ja=%d, pid=%d, seed=%u\n", ja, getpid(), seed);
  inicializuj();

  while (cin.good()) {
    nacitaj(cin, stav);
    mojTah = zaciatokTahu(stav, ja);
    zistiTah();
    uloz(cout, mojTah.prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

