#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <unistd.h>
#include <iostream>
#include <vector>
#include <queue>
#include <utility>
#include <algorithm>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"

// skratka. pouzivajte v zistiTah().
#define vykonaj(p) vykonajPrikaz(mapa, stav, mojTah, (p))
#define par(a,b) make_pair(a, b)

int A[9]={1,1,1,0,-1,-1,-1,0,0},
    B[9]={1,0,-1,-1,-1,0,1,1,0};

int ja;   // ktory hrac som
Mapa mapa;
Stav stav;
Tah mojTah;

pair<int,int> bfs(int x, int y, int cx, int cy, bool pmety) {
  int apa[mapa.h][mapa.w];
  for (int i=0; i<mapa.h; i++) {
    for (int j=0; j<mapa.w; j++) {
      apa[i][j]=-2;
    }
  }
  apa[y][x]=8;
  if (pmety) {
    FOREACH (p, stav.predmety) {
      apa[p->y][p->x]=47;
    }
  }
  queue<pair<pair<int,int>,int> > QQ;
  for (int i=0; i<8; i++) {
    if ((mapa.priechodne(x+A[i],y+B[i]))&&(apa[y+B[i]][x+A[i]]<47) ) {
      QQ.push(par(par(x+A[i],y+B[i]),0) );
      apa[y+B[i]][x+A[i]]=i;
    }
  }
  while (!QQ.empty()) {
    int X=QQ.front().first.first,
	Y=QQ.front().first.second,
	z=QQ.front().second;
    if ((X==cx)&&(Y==cy)) {
      /*fprintf(stderr, "vzdialenost %d smer %d\n", z, apa[Y][X]);
      for (int i=0; i<mapa.h; i++) {
	for (int j=0; j<mapa.w; j++) {
	  if (apa[i][j]>=0) fprintf(stderr, " %d ",apa[i][j]);
	  else fprintf(stderr, "%d ",apa[i][j]);
	}
	fprintf(stderr, "\n");
      }*/
      return par(z,apa[Y][X]);
    }
    for (int i=0; i<8; i++) {
      if (mapa.priechodne(X+A[i],Y+B[i])) {
	if (apa[Y+B[i]][X+A[i]]==-2) {
	  apa[Y+B[i]][X+A[i]]=apa[Y][X];
	  QQ.push(par(par(X+A[i],Y+B[i]),z+1) );
	}
      }
    }
    QQ.pop();
  }
  return par(999999,8); //z neznameho dovodu to nevyslo
}

// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
  // (sem patri vas kod)
}


// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
  // (sem patri vas kod)
  // priklad: if (vykonaj(Prikaz::chod(niekto, x, y))) { /* podarilo sa */ }

  // verbuj hrdinu
  int X, Y;
  do {
    X=rand()%mapa.w;
    Y=rand()%mapa.h;
  } while (mapa.zisti(X,Y) != MAPA_MESTO ) ;
  vykonaj(Prikaz::verbuj(1,X,Y));
  
  for (int OL=0; OL<6; OL++) {
    FOREACH (it, stav.zivocichy) {
      if (it->ktorehoHraca != ja) continue;
      int smer=8;
      if (it->nesenyPredmet >= 0) {
	FOREACH (q,stav.questy) {
	  if (q->ziadanyPredmet != it->nesenyPredmet) continue;
	  pair<int,int> ffs= bfs(it->x, it->y, q->cielX, q->cielY, true);
	  smer=ffs.second;
	}
      }
      else {
	double max=0;
	FOREACH (q, stav.questy) {
	  double lmax=0;
	  int lsmer=8;
	  FOREACH (p, stav.predmety) {
	    if (q->ziadanyPredmet != p->typ) continue;
	    pair<int,int> ffs= bfs(it->x, it->y, p->x, p->y, false);
	    pair<int,int> kks= bfs(p->x, p->y, q->cielX, q->cielY, false);
	    double vyh=double(999*q->zlato)/double(1 + ffs.first + kks.first);
	    if (vyh>lmax) {
	      lmax=vyh;
	      lsmer=ffs.second;
	    }
	  }
	  FOREACH (r, stav.zivocichy) {
	    if (q->ziadanyPredmet != r->nesenyPredmet) continue;
	    pair<int,int> ffs= bfs(it->x, it->y, r->x, r->y, false);
	    pair<int,int> kks= bfs(r->x, r->y, q->cielX, q->cielY, false);
	    double vyh=double(99*q->zlato)/double(1 + ffs.first + kks.first);
	    if (vyh>lmax) {
	      lmax=vyh;
	      lsmer=ffs.second;
	    }
	  }
	  if (lmax>max) {
	    max=lmax;
	    smer=lsmer;
	  }
	}
      }
      //pohni hrdinom
      if (mapa.zisti(it->x+A[smer],it->y+B[smer])==MAPA_MESTO) {
	vykonaj(Prikaz::poloz(it->id,it->x+A[smer],it->y+B[smer]));
      }
      else if (vykonaj(Prikaz::chod(it->id,it->x+A[smer],it->y+B[smer])) ) ;
      else if (vykonaj(Prikaz::utoc(it->id,it->x+A[smer],it->y+B[smer])) ) ;
    }
  }
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  unsigned int seed = time(NULL) * getpid();
  srand(seed);

  nacitaj(cin, ja);
  nacitaj(cin, mapa);
  fprintf(stderr, "START ja=%d, pid=%d, seed=%u\n", ja, getpid(), seed);
  inicializuj();

  while (cin.good()) {
    nacitaj(cin, stav);
    mojTah = zaciatokTahu(stav, ja);
    zistiTah();
    uloz(cout, mojTah.prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

