#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <unistd.h>
#include <iostream>
#include <vector>
#include <queue>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"


int ja;   // ktory hrac som
Mapa mapa;
Stav stav;
Tah mojTah;


// skratka. pouzivajte v zistiTah().
#define vykonaj(p) vykonajPrikaz(mapa, stav, mojTah, (p))

const int INF = 2000000047;

// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
  // (sem patri vas kod)
  cerr << "INICIALIZACIA\n";
  
}


// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
    cerr << "ZACINAM TAH\n";
    // (sem patri vas kod)
    // priklad: if (vykonaj(Prikaz::chod(niekto, x, y))) { /* podarilo sa */ }
  
    int pocetHrdinov = 0;
  
    // pozerame sa na hracov
    FOREACH(it, stav.zivocichy){
        if(it->ktorehoHraca == ja){
            pocetHrdinov++;
        }
    }
    cerr << "pocet hrdinov " << pocetHrdinov << endl;
    
    // tie ktore maju u seba predmet nech ho idu odniest
    int bfs_mapa[mapa.w][mapa.h];
    queue<pair<int,int> > Q;
  
    FOREACH(it, stav.zivocichy){
        if(it->ktorehoHraca == ja){
            for(int i = 0; i < mapa.w; i++) for(int j = 0; j < mapa.h; j++) bfs_mapa[i][j] = INF;
            if(it->nesenyPredmet != -1){
                // ak je nejaky quest, najlepsie najblizsi tak tam nes na plne obratky
                FOREACH(q, stav.questy){
                    if(q->ziadanyPredmet == it->nesenyPredmet){
                        Q.push(make_pair(q->cielX, q->cielY));
                        bfs_mapa[q->cielX][q->cielY] = 0;
                    }
                }
            }
            else continue;
            // BFS
            cerr << "Mam predmet " << it->nesenyPredmet << endl;
            cerr << "zacinam BFS\n";
            while(!Q.empty()){
                pair<int,int> bod = Q.front(); Q.pop();
                for(int k = 0; k < 8; ++k){
                    if(!mapa.priechodne(bod.first + DX[k], bod.second + DY[k])) continue;
                    if(bfs_mapa[bod.first][bod.second] + 1 < bfs_mapa[bod.first + DX[k]][bod.second + DY[k]]){
                        bfs_mapa[bod.first + DX[k]][bod.second + DY[k]] =  bfs_mapa[bod.first][bod.second] + 1;
                        Q.push(make_pair(bod.first + DX[k], bod.second + DY[k]));
                    }
                }
            }
            cerr << "koncim BFS\n";
            while(bfs_mapa[it->x][it->y] < INF){
                
                int mink = 0, minres = INF;
                for(int j = 0; j < 8; j++){
                    if(bfs_mapa[it->x + DX[j]][it->y = DY[j]] < minres){
                        mink = j;
                        minres = bfs_mapa[it->x + DX[j]][it->y = DY[j]];
                    }
                }
                if(bfs_mapa[it->x][it->y] == 1){
                    if(!vykonaj(Prikaz::poloz(it->id, it->x + DX[mink], it->y + DY[mink]))){
                        while(vykonaj(Prikaz::utoc(it->id, it->x + DX[mink], it->y + DY[mink])));
                    }  
                    vykonaj(Prikaz::poloz(it->id, it->x + DX[mink], it->y + DY[mink]));                  
                    break;
                }
                if(!vykonaj(Prikaz::chod(it->id, it->x + DX[mink], it->y + DY[mink]))) break;
            }
        }
    }  
  
    // tie ktore ho nemaju sa nech pozru na zoznam wquestov, ci je tam druh z mesta do mesta
    // ak su a nie su u ineho hraca, tak pod za nim 
    // je jedno ze vsetci idu na ten isty
    
    FOREACH(it, stav.zivocichy){
        if(it->ktorehoHraca == ja && it->nesenyPredmet == -1){
            cerr << "som hrdina " << it->id << " a nemam predmet :( \n"; 
        }
    }
   
   
    // ak mam malo hracov (cca 2) a stale mam AP tak si niekoho vyrobim, najlepsie najrychlejsieho
    // a pokus sa vyrobit ho najblizsie ku nejakemu questu
    int pocetPonuk = 0;
    FOREACH(it, stav.pracovnePonuky){
        if(it->ktorehoHraca == ja) pocetPonuk++;
    }
    while(pocetHrdinov + pocetPonuk< 2 && kApVerbuj <= mojTah.ap){
        for (int y = 0; y < mapa.h && pocetPonuk + pocetHrdinov < 2; y++) {
            for (int x = 0; x < mapa.w && pocetPonuk + pocetHrdinov < 2; x++) {
                if (mapa.zisti(x, y) == MAPA_MESTO) {
                    if(vykonaj(Prikaz::verbuj(rand() % HRDINA_POCET_TYPOV, x, y))) pocetPonuk++;
                }
            }
        }
    }
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  unsigned int seed = time(NULL) * getpid();
  srand(seed);

  nacitaj(cin, ja);
  nacitaj(cin, mapa);
  fprintf(stderr, "START ja=%d, pid=%d, seed=%u\n", ja, getpid(), seed);
  inicializuj();

  while (cin.good()) {
    nacitaj(cin, stav);
    mojTah = zaciatokTahu(stav, ja);
    zistiTah();
    uloz(cout, mojTah.prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

