#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <unistd.h>
#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"


int ja;   // ktory hrac som
Mapa mapa;
Stav stav;
Tah mojTah;

// TODO pamatatat si kde mna zabili


// skratka. pouzivajte v zistiTah().
#define vykonaj(p) vykonajPrikaz(mapa, stav, mojTah, (p))

template<class T> unsigned najdiXy(const vector<T>& v, int x, int y) {
  for (unsigned i = 0; i < v.size(); i++) if (v[i].x == x && v[i].y == y) return i;
  return v.size();
}

const int INF = 2000000047;
const double eps = 1e-7;
const int chcemHrdinov = 2;
   
const int LOOT = 0;
const int PVP = 1;
const int MVP = 2;
const int ODNES = 3;

bool agressive = true;

int pocetHrdinov = 0;
int pocetPonuk = 0;


int raw_dist[200][90][200][90];
//#define pure_dist(a,b,c,d) ((mapa.priechodne(a,b) && mapa.priechodne(c,d)) ? raw_dist[a][b][c][d] : INF)
#define pure_dist(a,b,c,d) ((mapa.priechodne(a,b) && mapa.priechodne(c,d)) ? max(abs(c - a), abs(d - b)) : INF)

int kol_na_kill(vector<Zivocich>::iterator a, vector<Zivocich>::iterator b){
    if(a->ktorehoHraca != -1){
        return ceil(1.00*b->hp*(3)/(1.00*kApZasoba/pocetHrdinov));
    }
    else{
        return ceil(1.00*b->hp*(2.5)/(1.00*7));
    }
}


bool vedia_bojovat(vector<Zivocich>::iterator a, vector<Zivocich>::iterator b){
    // ci je A silnejsi ako B
    
    if(b->ktorehoHraca == -1){
        // prisera
        
        if(mapa.zisti(b->x, b->y) != MAPA_TEMNA_ZEM || stav.cas < 0.7 * kDlzkaHry){
            return kol_na_kill(a,b) + 1 >= kol_na_kill(b,a) ;
        }
        else{
            return false;
        }
        
    }
    else{
        // iny hrac
        return (mapa.zisti(b->x, b->y) != MAPA_TEMNA_ZEM || stav.cas < 0.3 * kDlzkaHry);
        // TODO zatial viem aproximovat 
    }
    
    
}

pair<int,int> BFS(const int x, const int y,const int cielX,const int cielY, bool agressive=false){
    // ans == 0 znamena ze chcem dialku
    // ans == 1 znamena ze chcem smer
    
    // ak neuspech tak -1
    
    //cerr << "robim BFS  " << x << "," << y << "\t-> " << cielX << "," << cielY << endl;
    
    int bfs_mapa[mapa.w][mapa.h];
    for(int i = 0; i < mapa.w; ++i) for(int j = 0; j < mapa.h; ++j) bfs_mapa[i][j] = INF;
    bfs_mapa[cielX][cielY] = 0;
    queue<int> Q;
    Q.push(cielX); Q.push(cielY);
    
    while(!Q.empty()){
        int px = Q.front(); Q.pop();
        int py = Q.front(); Q.pop();
        
        for(int k = 0; k < 8; ++k){
            bool jeTamZivocich = (najdiXy(stav.zivocichy, px + DX[k], py + DY[k]) != stav.zivocichy.size());
            bool jeTamPredmet = (najdiXy(stav.predmety, px + DX[k], py + DY[k]) != stav.predmety.size());
            if (!agressive && jeTamZivocich && !(px+DX[k] == x && py+DY[k] == y)) continue;        
            if(jeTamPredmet) continue;
            
            if(mapa.priechodne(px+DX[k], py+DY[k]) && bfs_mapa[px+DX[k]][py+DY[k]] > bfs_mapa[px][py] + 1){
                bfs_mapa[px+DX[k]][py+DY[k]] = bfs_mapa[px][py] + 1;
                Q.push(px+DX[k]); Q.push(py + DY[k]);
            }
        }
    }
    //cerr << "koncim BFS\n"; 
    
    if(bfs_mapa[x][y] == INF){return make_pair(-1,-1);}
    
    pair<int,int> ans;
    ans.first = bfs_mapa[x][y];
    
    int mink = 0, best_dist = INF;
    for(int i = 0; i < 8; ++i){
        if(bfs_mapa[x+DX[i]][y+DY[i]] < best_dist){
            best_dist = bfs_mapa[x+DX[i]][y+DY[i]];
            mink = i;
        }
    }
    ans.second = mink;
    return ans;    
}

int ktorymSmerom(const int x, const int y,const int cielX,const int cielY, bool agressive=false){
    return BFS(x,y,cielX,cielY,agressive).second;
}

int dlzkaCesty(const int x, const int y,const int cielX,const int cielY, bool agressive=false){
    return BFS(x,y,cielX,cielY,agressive).first;
}

void nahodneZverbuj(){ 
    // ak je dost AP tak vyber nahodne mesto a tam zavolaj nahodny typ ktory este nie je v ponuke a ani v poli
    bool uspech = false;
    vector<pair<int,int> > mesta; 
    for(int i = 0; i < mapa.w; ++i) for(int j = 0; j < mapa.h; ++j) 
        if(mapa.zisti(i,j) == MAPA_MESTO){mesta.push_back(make_pair(i,j));}
    
    while(!uspech && mojTah.ap >= kApVerbuj){
        int fs = rand()%mesta.size();
        uspech = (vykonaj(Prikaz::verbuj(rand()%HRDINA_POCET_TYPOV, mesta[fs].first, mesta[fs].second)));
    }
    cerr << "som zverboval\n" << endl;
 }



bool zdvihnut = false;
int id_zdvih;
int cielX_zdvih;
int cielY_zdvih;

void zdvihni(int id, int cielX, int cielY){
    zdvihnut = false;
    vector<Zivocich>::iterator it = stav.zivocichy.end(); FOREACH(itt, stav.zivocichy) if(itt->id == id) it = itt;
    if(it != stav.zivocichy.end()){
        bool stale_lezi = false;
        FOREACH(item, stav.predmety) if(item->x == cielX && item->y && cielY){ stale_lezi = true; break;}
        if(!stale_lezi) return;
        
        pair<int,int> good = make_pair(-47,-47);
        for(int k = 0; k < 8; ++k){
            if(vzdialenost(it->x, it->y, cielX+DX[k], cielY + DY[k]) && mapa.priechodne(cielX+DX[k], cielY + DY[k]) && 
                najdiXy(stav.predmety, cielX+DX[k], cielY + DY[k]) == stav.predmety.size() &&
                najdiXy(stav.zivocichy, cielX+DX[k], cielY+DY[k]) == stav.zivocichy.size()){ 
                good = make_pair(cielX+DX[k], cielY+DY[k]); break;
            }
            if(good != make_pair(-47,-47)){
                cerr << "hura, pome to menit\n";
                pair<int,int> from = make_pair(it->x,it->y);
                vykonaj(Prikaz::poloz(it->id, good.first, good.second));
                vykonaj(Prikaz::chod(it->id, cielX, cielY));
                vykonaj(Prikaz::poloz(it->id,from.first,from.second));
                vykonaj(Prikaz::chod(it->id, good.first, good.second));
                vykonaj(Prikaz::poloz(it->id, cielX, cielY));
            }
        }
    }
}

void treba_zdvihnut_kamen(vector<Zivocich>::iterator it, int cielX, int cielY){
    zdvihnut = true;
    id_zdvih = it->id;
    cielX_zdvih = cielX;
    cielY_zdvih = cielY;
}


int pohni(vector<Zivocich>::iterator it, pair<int,int> best_pos, int typ = LOOT){
    bool mozem_sa_hybat = true;
    int cielX = best_pos.first, cielY = best_pos.second;
    cerr << "pohni " << it->id << " do " << best_pos.first << "," << best_pos.second << " \t: " << typ << endl;
    
    bool uz_som_utocil = false;
    while(mozem_sa_hybat && mojTah.ap > 0 && !uz_som_utocil){
        pair<int,int> z_bfs = BFS(it->x,it->y,best_pos.first,best_pos.second);
        int dist = z_bfs.first; 
        int k = z_bfs.second;
        
        if(dist == -1){
            cerr << "smola, neda sa dosiahnut" << endl;
            return -1;
        }        
        
        if(dist == 0){
            cerr << "vzdialenost je 0 ???\n";
            return -1;
        }
        
        // TODO ked pribudne rozsirenie mesta
        if(typ == ODNES && dist == 2){
            bool da = false;
            for(int k = 0; k < 8; ++k) da = da || vykonaj(Prikaz::poloz(it->id, cielX + DX[k], cielY + DY[k]));
            if(da) return 0;
        }
        
        if(dist > 1){
            cerr << "je to pridaleko, musim kracat" << endl;
            int cena = zistiApCenu(mapa,stav,mojTah,Prikaz::chod(it->id, it->x + DX[k], it->y + DY[k]));
            cerr << "stalo by to " << cena << endl;
            
            if(cena == -1){
                cerr << "nemozem tam ist :(" << endl; 
                return -1;
            }
            else if(cena > mojTah.ap){
                cerr << "uz som vsetko minul :(" << endl;
                mozem_sa_hybat = false;
                return -1;
            }
            
            if(1.00*(kApZasoba - pocetHrdinov*kApJedlo)/pocetHrdinov >= cena){
                cerr << "nie je toho vela, mozem skusit :)" << endl;
                if(vykonaj(Prikaz::chod(it->id, it->x + DX[k], it->y + DY[k]))){
                    cerr << "som sa pohol" << endl;
                }
                else{
                    cerr << "nepodarilo sa mi pohnut" << endl;
                    cerr << "skusim zautocit" << endl;
                    while(vykonaj(Prikaz::utoc(it->id, it->x + DX[k], it->y + DY[k])));
                }
            }
            else{
                cerr << "je toho trochu vela, ale ja som carovny :P" << endl;
                return -1;
            }
        }
        else{
            cerr << "zostava iba krok! musim splnit svoj ucel!" << endl;
            switch(typ){
            case LOOT:{
                cerr << "LOOT" << endl;
                if(vykonaj(Prikaz::chod(it->id, cielX, cielY))){
                    cerr << "som LOOTol" << endl;
                    return 0;
                }
                else{
                    cerr << ":( som neLOOTol" << endl;
                    return -1;
                }
            }; break; 
            case PVP:{
                while(vykonaj(Prikaz::utoc(it->id, cielX, cielY)));
                if(vykonaj(Prikaz::chod(it->id, cielX, cielY))) return 0;
                else return -1;
            }; break; 
            case MVP:{
                while(vykonaj(Prikaz::utoc(it->id, cielX, cielY)));
                if(vykonaj(Prikaz::chod(it->id, cielX, cielY))) return 0;
                else return -1;
            }; break; 
            case ODNES:{
                
                cerr << "toto chce mesto pri ktorom stojim. tak tu vec zhodim" << endl;
                if(vykonaj(Prikaz::poloz(it->id, cielX,cielY))){
                    cerr << "hura, som polozil" << endl;
                    return 0;
                }                
                else{
                    bool da = false;
                    for(int k = 0; k < 8; ++k) da = da || vykonaj(Prikaz::poloz(it->id, cielX + DX[k], cielY + DY[k]));
                    if(da) return 0;
        
                
                    while(vykonaj(Prikaz::utoc(it->id, cielX, cielY)));
                    if(vykonaj(Prikaz::poloz(it->id, cielX, cielY))){
                        cerr << "hura som polozil" << endl;
                        return 0;
                    }
                    else{
                        if(!uz_som_utocil) uz_som_utocil = true;
                        else{
                            cerr << "PREDMET ZAVADZA!!" << endl;
                            treba_zdvihnut_kamen(it, cielX, cielY);
                        }
                        return -1;
                    }
                }
            }; break;             
            }
            return -1;
        }
    }
    return 0;
}

void robNahodaciny(){
    cerr << "HARLEM SHAKE!!!\n";
    FOREACH(it, stav.zivocichy) if(it->ktorehoHraca == ja){
        int smer = rand()%8;
        while(rand()%3 == 2 && smer-- > 0) vykonaj(Prikaz::chod(it->id, it->x + DX[smer], it->y + DY[smer]));
    }
}

void ocista(){
    FOREACH(it, stav.zivocichy) if(it->ktorehoHraca == ja && it->nesenyPredmet != -1){
        bool potrebny = false;
        FOREACH(q, stav.questy) if(q->ziadanyPredmet == it->nesenyPredmet){ potrebny = true; break;}
        if(!potrebny){
            for(int i = 0; i < 8 && it->nesenyPredmet != -1 && mojTah.ap > 0; ++i){
                if(vykonaj(Prikaz::poloz(it->id, it->x + DX[i], it->y + DY[i]))) break;
            }
            if(it->nesenyPredmet == -1) cerr << "predmet je vyhodeny\n";
        }
    }
        
    
}

// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
    /*queue<int> Q;   
    for(int i1 = 0; i1 < mapa.w; ++i1) for(int j1 = 0; j1 < mapa.h; ++j1){
        if(mapa.priechodne(i1,j1) == -1) continue;
        for(int i2 = 0; i2 < mapa.w; ++i2) for(int j2 = 0; j2 < mapa.h; ++j2)
            raw_dist[i1][j1][i2][j2] = INF;
        raw_dist[i1][j1][i1][j1] = 0;
        Q.push(i1); Q.push(j1);
        while(!Q.empty()){
            int x = Q.front(); Q.pop();
            int y = Q.front(); Q.pop();
            for(int k = 0; k < 8; ++k){
                if(mapa.priechodne(x+DX[k],y+DY[k]) && raw_dist[i1][j1][x+DX[k]][y+DY[k]] > raw_dist[i1][j1][x][y] + 1){
                    raw_dist[i1][j1][x+DX[k]][y+DY[k]] = raw_dist[i1][j1][x][y] + 1;
                    Q.push(x + DX[k]); Q.push(y + DY[k]);
                }
            }
        }
    }
    cerr << "raw_dist computation completed\n";*/
}

// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
    pocetHrdinov = 0; FOREACH(it, stav.zivocichy) if(it->ktorehoHraca == ja) ++pocetHrdinov;    
    pocetPonuk = 0;   FOREACH(it, stav.pracovnePonuky) if(it->ktorehoHraca == ja) ++pocetPonuk;
    cerr << "hrdinovia: " << pocetHrdinov << "/" << pocetPonuk << endl;
    
    if(zdvihnut) zdvihni(id_zdvih, cielX_zdvih, cielY_zdvih);
    
    if(pocetHrdinov + pocetPonuk < chcemHrdinov){
        cerr << "moc malo ludi, idem verbovat jedneho nahodne" << endl;
        nahodneZverbuj();
    }
    if(pocetHrdinov == 0){ cerr << "nemam hrdinov, koncim tah\n"; return;}
    
    if(rand()%47 == 42){
        robNahodaciny();
    }
    
    //rozoberat jednotlive questy
    
    double best_rate = 0;
    int best_typ = LOOT;
    pair<int,int> best_pos;
    vector<Zivocich>::iterator best_hrdina;
    
     
    // mam tri moznosti
    // bud to najst na zemi --> almost no risk, but sometimes lots of monsters and low price
    // oplati sa potom asi najkratsia podla suctu ciest. prisery ??
    
    // alebo to zobrat hracovi --> trva iba chvilu, lebo sa urcite ponahla
    // pozriet sa, kam sa ponahla ?? lebo asi to bude lepsie ako utekat priamociaro za nim??
    // v okoli mesta ale moze rychlo utiect
    // je uplne super moznost je, ze niekto uz zabil tu silnu priseru a ponahla sa domov >:-)
    
    // alebo to zobrat prisere --> casto su v skupine, treba si vsimunt ich agresivitu
    
    // ako sa rozhodnut?? ak mam malo HP, tak urcite to prve, lebo to najmenej boli
    
    bool su_questy = true;
    map<int,int> zoznam;
    FOREACH(it, stav.zivocichy) if(it->ktorehoHraca == ja) zoznam[it->id] = 0;
    while(mojTah.ap > 0 && su_questy){
        su_questy = false;
        best_rate = 0;
        FOREACH(q, stav.questy){
            // kazdy quest ma 3 sposoby riesenia
            // chceme vybrat najrychlejsi co vieme splnit v ramci questu
            // ako globalny parameter si vezmeme mnozstvo peniazi/mnozstvo casu
            
            cerr << "quest " << q->ziadanyPredmet << "(zlato: " << q->zlato << ")" <<  endl;
            
            int dist[4]; for(int ii = 0; ii < 4; ++ii) dist[ii] = INF;
            pair<int,int> pos[4];
            vector<Zivocich>::iterator hrdina[4];
             
             
            //prva moznost
            FOREACH(it, stav.zivocichy) if(it->ktorehoHraca == ja && zoznam[it->id] != -1 && it->nesenyPredmet == -1){
                FOREACH(item, stav.predmety) if(item->typ == q->ziadanyPredmet){
                    cerr << "aha, tento item je na zemi\n";
                    //int curr_dist = dlzkaCesty(it->x, it->y, item->x, item->y) + dlzkaCesty(item->x, item->y, q->cielX, q->cielY);
                    int curr_dist = pure_dist(it->x, it->y, item->x, item->y) + pure_dist(item->x, item->y, q->cielX, q->cielY);
                    if(curr_dist < dist[LOOT]){
                        dist[LOOT] = curr_dist;
                        pos[LOOT] = make_pair(item->x, item->y);
                        hrdina[LOOT] = it;
                        su_questy = true;
                    }
                }
            }
            
            cerr << "first dist is\t" << dist[0] << endl;
            
            // druha moznost : okradnut 
            // iba ak viem ho dostat na jeedn tah
            FOREACH(enemy, stav.zivocichy) if(enemy->ktorehoHraca != -1 && 
                                              enemy->ktorehoHraca != ja && 
                                              enemy->nesenyPredmet == q->ziadanyPredmet  
                                              ){
                cerr << "aha, je iny hrac s takym predmetom" << endl;
                FOREACH(it, stav.zivocichy) if(it->ktorehoHraca == ja && zoznam[it->id] != -1 && it->nesenyPredmet == -1 && vedia_bojovat(it, enemy) && pure_dist(enemy->x, enemy->y, it->x, it->y) < 5){
                    int curr_dist = pure_dist(it->x, it->y, enemy->x, enemy->y) + pure_dist(enemy->x, enemy->y, q->cielX, q->cielY);
                    if(curr_dist < dist[PVP]){
                        dist[PVP] = curr_dist;
                        pos[PVP] = make_pair(enemy->x, enemy->y);
                        hrdina[PVP] = it;
                        su_questy = true;
                    }
                }
            }
            
            
            cerr << "second dist is\t" << dist[1] << endl;
            dist[1] = 2*dist[1];
            
            // tretia moznost: PVM
            FOREACH(mon, stav.zivocichy) if(mon->ktorehoHraca == -1 && mon->nesenyPredmet == q->ziadanyPredmet){
                FOREACH(it, stav.zivocichy) if(it->ktorehoHraca == ja && zoznam[it->id] != -1 && 
                        it->nesenyPredmet == -1 && vedia_bojovat(it, mon)){
                    int curr_dist = pure_dist(it->x, it->y, mon->x, mon->y) + pure_dist(mon->x, mon->y,q->cielX, q->cielY);
                    if(curr_dist < dist[MVP]){
                        dist[MVP] = curr_dist;
                        pos[MVP] = make_pair(mon->x, mon->y);
                        hrdina[MVP] = it;
                        su_questy = true;
                    }
                }
            }
            
            
            cerr << "third dist is\t" << dist[2] << endl;
            
            
            // stvrta moznost: niekto z mojich to uz ma
            FOREACH(it, stav.zivocichy) if(it->ktorehoHraca == ja && zoznam[it->id] != -1 && it->nesenyPredmet == q->ziadanyPredmet){
                int curr_dist = pure_dist(it->x, it->y, q->cielX, q->cielY);
                    if(curr_dist < dist[ODNES]){
                        dist[ODNES] = curr_dist;
                        pos[ODNES] = make_pair(q->cielX, q->cielY);
                        hrdina[ODNES] = it;
                        su_questy = true;
                    }
            } 
            
            
            cerr << "forth dist is\t" << dist[3] << endl;
            if(dist[3] != INF) dist[3] = 0.67 * dist[3];
            
            for(int i = 0; i < 4; ++i) if(best_rate < 1.00*q->zlato/dist[i]){
                best_rate = 1.00*q->zlato/dist[i];
                best_typ = i;
                best_pos = pos[i];
                best_hrdina = hrdina[i];
            }
        }
    
    
        if(max(best_rate, - best_rate) < eps){
            cerr << "ziaden quest nie je dobry" << endl;    
            ocista();
            robNahodaciny();
            ocista();
            return;
        }
        else{
            if(pohni(best_hrdina, best_pos, best_typ) == -1) zoznam[best_hrdina->id] = -1;
        }
    }
    cerr << "koniec mojho tahu\n";
    cerr << "==================\n";
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  unsigned int seed = time(NULL) * getpid();
  srand(seed);

  nacitaj(cin, ja);
  nacitaj(cin, mapa);
  fprintf(stderr, "START ja=%d, pid=%d, seed=%u\n", ja, getpid(), seed);
  inicializuj();

  while (cin.good()) {
    nacitaj(cin, stav);
    mojTah = zaciatokTahu(stav, ja);
    zistiTah();
    uloz(cout, mojTah.prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

