#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <unistd.h>
#include <iostream>
#include <vector>
using namespace std;

#include "common.h"
#include "marshal.h"
#include "update.h"


int ja;   // ktory hrac som
Mapa mapa;
Stav stav;
Tah mojTah;


// skratka. pouzivajte v zistiTah().
#define vykonaj(p) vykonajPrikaz(mapa, stav, mojTah, (p))


// main() zavola tuto funkciu, ked nacita mapu
void inicializuj() {
  // (sem patri vas kod)
}


int sgn(int c) {
  if (c < 0) return -1;
  if (c > 0) return 1;
  return 0;
}


// main() zavola tuto funkciu, ked chce vediet, ake prikazy chceme vykonat
void zistiTah() {
  // (sem patri vas kod)
  // priklad: if (vykonaj(Prikaz::chod(niekto, x, y))) { /* podarilo sa */ }

  // mam malo hrdinov? hura verbovat!
  int mojiHrdinovia = 0;
  FOREACH (it, stav.zivocichy) {
    if (it->ktorehoHraca == ja) mojiHrdinovia++;
  }
  if (mojiHrdinovia < kMaximumHrdinovHraca) {
    for (int y = 0; y < mapa.h; y++) {
      for (int x = 0; x < mapa.w; x++) {
        if (mapa.zisti(x, y) == MAPA_MESTO) {
          vykonaj(Prikaz::verbuj(rand() % HRDINA_POCET_TYPOV, x, y));
        }
      }
    }
  }

  // ked uz mam hrdinov, tak nimi pohnem
  bool poholSomSa;
  do {
    poholSomSa = false;

    // skusim kazdemu dat jeden prikaz
    FOREACH (it, stav.zivocichy) {
      if (it->ktorehoHraca != ja) continue;

      // najdem najblizsiu potvoru
      int bestx = -1, besty = -1, bestd = mapa.w * mapa.h;
      FOREACH (itp, stav.zivocichy) {
        if (itp->ktorehoHraca != -1) continue;
        int d = vzdialenost(it->x, it->y, itp->x, itp->y);
        if (d < bestd) {
          bestx = itp->x;
          besty = itp->y;
          bestd = d;
        }
      }

      if (bestx == -1) {
        // ak tam nie je ziadna potvora, nahodne sa pohnem
        int nx = it->x + rand() % 3 - 1;
        int ny = it->y + rand() % 3 - 1;
        if (vykonaj(Prikaz::chod(it->id, nx, ny))) poholSomSa = true;
      }
      else if (bestd == 1) {
        // ak je hned pri mne, zautocim
        if (vykonaj(Prikaz::utoc(it->id, bestx, besty))) poholSomSa = true;
      }
      else {
        // ak je dalej, vydam sa tym smerom
        int nx = it->x + sgn(bestx - it->x);
        int ny = it->y + sgn(besty - it->y);
        if (vykonaj(Prikaz::chod(it->id, nx, ny))) poholSomSa = true;
      }
    }

    // mozno mi este zostali AP - zase skusim kazdym pohnut...
    // (ak uz sa nikto pohnut nedokazal, nejdem to dalej skusat)
  } while (poholSomSa);

  if (mojTah.ap) {
    // napriklad takto sa vypisuju debugovacie spravy
    fprintf(stderr, "este mi zostalo %d Action Points\n", mojTah.ap);
  }
}


int main() {
  // v tejto funkcii su vseobecne veci, nemusite ju menit (ale mozte).

  unsigned int seed = time(NULL) * getpid();
  srand(seed);

  nacitaj(cin, ja);
  nacitaj(cin, mapa);
  fprintf(stderr, "START ja=%d, pid=%d, seed=%u\n", ja, getpid(), seed);
  inicializuj();

  while (cin.good()) {
    nacitaj(cin, stav);
    mojTah = zaciatokTahu(stav, ja);
    zistiTah();
    uloz(cout, mojTah.prikazy);
    cout << ".\n" << flush;   // bodka a flush = koniec odpovede
  }

  return 0;
}

