#include "marshal.h"
#include "common.h"
#include "SDL.h"
#include "SDL_ttf.h"
#include "SDL_image.h"
#include "observer.h"
#include <cstdio>
#include <cstdlib>
#include <fstream>
#include <vector>
#include <string>
using namespace std;

char* working_dir;
const char* log_container = "../zaznamy/";
char* log_dir;

int BUFFER_SIZE = 1000;

int NUM_PLAYERS = 0;
int PLAYER_ORDER[MAX_PLAYERS];
int REVERSE_PLAYER_ORDER[MAX_PLAYERS];
char PLAYER_NAMES[MAX_PLAYERS][MAX_NAME_LENGTH];

int LOG_FORMAT = 1;
int TURNS_COUNT = 0;
vector<string> observations;

vector<Stav> states;
vector<Odpoved> answers;

char* getFile(const char* filename) {
  /* prependuj meno adresara pred meno suboru */
  /* toto evidentne leakuje, ale vola sa to len konstantne casto */
  /* proboj \in LEAK(O(1)) */
    
  char* ret = (char*)malloc(sizeof(char) * (strlen(working_dir) + strlen(filename) + 1));
  strcpy(ret, working_dir);
  strcpy(ret + strlen(working_dir), filename);
        
  return ret;
}

char* getLogFile(const char* filename) {
  /* podobne ako getFile, ale dava subor z adresaru zaznamy/ */
  
  char* ret = (char*)malloc(sizeof(char) * (strlen(log_dir) + strlen(filename) + 1));
  strcpy(ret, log_dir);
  strcpy(ret + strlen(log_dir), filename);
      
  return ret;
}

void loadData(char* location, char* logname) {  
  /* zisti meno adresara */
  int len = strlen(location) - 1;
  while (len > 0 && location[len] != '/') --len;
  
  working_dir = (char*)malloc(sizeof(char) * (len + 2));
  for (int i = 0; i < len; i++)
    working_dir[i] = location[i];
  working_dir[len] = '/';
  working_dir[len + 1] = '\0';
    
  /* najdi adresar s logmi */
  log_dir = (char*)malloc(sizeof(char) * (strlen(logname) + 2));
  strcpy(log_dir, logname);
  log_dir[strlen(logname)] = '/';
  log_dir[strlen(logname) + 1] = '\0';
      
  /* nacitaj format */
  FILE* version_file = fopen(getLogFile("format"), "r");
  if (fscanf(version_file, "%d", &LOG_FORMAT)) {};
  fclose(version_file);
  
  /* nacitaj observacie */
  char buffer[BUFFER_SIZE];
  FILE* observation_file = fopen(getLogFile("observation"), "r");
  while (fgets(buffer, MAX_OBSERVATION_LENGTH, observation_file) != NULL)
    observations.push_back(buffer);
  fclose(observation_file);
  
  /* zisti pocet tahov */
  TURNS_COUNT = 0;
  for (int i = 0; i < (int)observations.size(); i++) {
    sscanf(observations[i].c_str(), "%s", buffer);
    if (!strcmp(buffer, "vykonajPozadie"))
      ++TURNS_COUNT;
  }
      
  /* nacitaj log */
  ifstream log_file (getLogFile("log"), istream::in);
  vector<int> order;
  
  nacitaj(log_file, order);
  for (int i = 0; i < (int)order.size(); i++) {
    PLAYER_ORDER[i] = order[i];
    REVERSE_PLAYER_ORDER[order[i]] = i;
  }
    
  for (int i = 0; i <= TURNS_COUNT; i++) {
    Stav stav;
    Odpoved odpoved;

    nacitaj(log_file, stav);
    if (log_file.fail()) fprintf(stderr, "Neviem nacitat log!\n"), exit(1);    
    states.push_back(stav);
    
    if (i == TURNS_COUNT) break;
    
    nacitaj(log_file, odpoved);
    if (log_file.fail()) fprintf(stderr, "Neviem nacitat log!\n"), exit(1);
    answers.push_back(odpoved);
  }
  
  /* mena hracov */
  for (int i = 0; i < MAX_PLAYERS; i++) {
    sprintf(PLAYER_NAMES[i], "Druzinka %d", i);
  }
  
  FILE* titles_file = fopen(getLogFile("titles"), "r");
    
  int title_counter = 0;
  if (titles_file != NULL) {
    while (true) {
      if (fgets(buffer, BUFFER_SIZE - 1, titles_file) == NULL) break;
      if (fgets(buffer, BUFFER_SIZE - 1, titles_file) == NULL) break;
      if (fgets(buffer, BUFFER_SIZE - 1, titles_file) == NULL) break;
    
      strcpy(PLAYER_NAMES[title_counter++], buffer);
      
      while (PLAYER_NAMES[title_counter - 1][strlen(PLAYER_NAMES[title_counter - 1]) - 1] == '\r' ||
             PLAYER_NAMES[title_counter - 1][strlen(PLAYER_NAMES[title_counter - 1]) - 1] == '\n') {
        PLAYER_NAMES[title_counter - 1][strlen(PLAYER_NAMES[title_counter - 1]) - 1] = '\0';
      }
      
    }
    
    fclose(titles_file);    
  }
  
  /* sentinely */
  Stav sentinel_stav = states[states.size() - 1];
  states.push_back(sentinel_stav);
  answers.resize(answers.size() + 1);
}
