#include <vector>

#if SDL_BYTEORDER == SDL_BIG_ENDIAN
  #define rmask 0xff000000
  #define gmask 0x00ff0000
  #define bmask 0x0000ff00
  #define amask 0x000000ff
#else
  #define rmask 0x000000ff
  #define gmask 0x0000ff00
  #define bmask 0x00ff0000
  #define amask 0xff000000
#endif

#define DISPLAY_WIDTH 1024L
#define DISPLAY_HEIGHT 768L

#define INFOBAR_HEIGHT 416
#define RIGHTBAR_WIDTH 224

#define TILE_WIDTH 4
#define TILE_HEIGHT 4
#define ZOOM_TILE_WIDTH 28
#define ZOOM_TILE_HEIGHT 36

#define ZOOMMAP_WIDTH 11
#define ZOOMMAP_HEIGHT 11

#define TEXTURE_WIDTH 28
#define TEXTURE_HEIGHT 36

#define FIGURE_ICON_WIDTH 8
#define FIGURE_ICON_HEIGHT 8
#define FIGURE_WIDTH 28
#define FIGURE_HEIGHT 36

#define FIGURE_ICON_X_SHIFT (FIGURE_ICON_WIDTH - TILE_WIDTH)
#define FIGURE_ICON_Y_SHIFT (FIGURE_ICON_HEIGHT - TILE_HEIGHT)

#define MARKRECT_WIDTH 2
#define MARKRECT_COLOR 0xFFFFFFFF

#define COLOR_BLACK ((SDL_Color){0x00, 0x00, 0x00, 0xFF})
#define COLOR_GREEN ((SDL_Color){0x00, 0xE0, 0x00, 0xFF})
#define COLOR_YELLOW ((SDL_Color){0xE0, 0xE0, 0x00, 0xFF})
#define COLOR_ORANGE ((SDL_Color){0xFF, 0xE0, 0x00, 0xFF})

#define MAX_PLAYERS 10
#define NUM_UNITS HRDINA_POCET_TYPOV
#define NUM_MONSTERS 6

#define MAX_OBSERVATION_LENGTH 200
#define MAX_NAME_LENGTH 200

#define GAMETIME_UNITS 1000
#define GAMETIME_DEFAULT_INCREMENT 200
#define GAMETIME_CHANGERATE 50

#define FPS 25
#define ENDGAME_DELAY 2

#define QUEST_ICON_SIZE 32

#define IDLING_MILLISECONDS 4000

extern SDL_Color PLAYER_COLORS[MAX_PLAYERS];

extern int LOG_FORMAT;
extern int TURNS_COUNT;
extern int PLAYER_ORDER[MAX_PLAYERS];
extern int REVERSE_PLAYER_ORDER[MAX_PLAYERS];
extern char PLAYER_NAMES[MAX_PLAYERS][MAX_NAME_LENGTH];
extern int NUM_PLAYERS;

extern int MAP_WIDTH;
extern int MAP_HEIGHT;

extern int game_time;
extern int game_time_increment;

extern std::vector<Stav> states;
extern std::vector<Odpoved> answers;

extern TTF_Font *bigfont, *smallfont, *hugefont;
extern SDL_Surface* map_background;

extern void drawQuests(SDL_Surface*, std::vector<Quest>);
extern void loadQuestImages();

extern SDL_Surface* money_icon;
extern SDL_Surface* medal_icon;
extern SDL_Surface* medal_icon_2;
extern SDL_Surface* medal_icon_3;
extern SDL_Surface* medal_icon_4;
extern SDL_Surface* medal_icon_5;

extern void loadMap();
extern void drawZoomMap(SDL_Surface* , SDL_Rect, SDL_Surface*, SDL_Rect);

extern void loadFigures();
extern void renderFigures(SDL_Surface*, SDL_Rect, int, int);
extern void renderSmallFigures(SDL_Surface*, SDL_Rect);

extern char* getFile(const char*);
extern char* getLogFile(const char*);
extern void loadData(char*, char*);

extern int getMiliseconds();
extern void compensateFPS();

extern int interestingX;
extern int interestingY;
extern void trackInterest();
extern void mouseTrack(SDL_MouseButtonEvent, SDL_Rect);
extern void keyTrack(SDL_KeyboardEvent);

extern void renderAdditionalInfo(SDL_Surface*, SDL_Rect);
