#include "marshal.h"
#include "common.h"
#include "SDL.h"
#include "SDL_ttf.h"
#include "SDL_image.h"
#include "observer.h"

#include <vector>
using namespace std;

SDL_Surface* quest_background;
SDL_Surface* money_icon;
SDL_Surface* time_icon;

SDL_Surface *medal_icon, *medal_icon_2, *medal_icon_3, *medal_icon_4, *medal_icon_5;

int QUEST_HEIGHT = 0;

void loadQuestImages() {
  quest_background = IMG_Load(getFile("quests/background.png"));
  money_icon = IMG_Load(getFile("quests/money.png"));
  time_icon = IMG_Load(getFile("quests/time.png"));
  medal_icon = IMG_Load(getFile("quests/medal.png"));  
  medal_icon_2 = IMG_Load(getFile("quests/medal2.png"));
  medal_icon_3 = IMG_Load(getFile("quests/medal3.png"));
  medal_icon_4 = IMG_Load(getFile("quests/medal4.png"));
  medal_icon_5 = IMG_Load(getFile("quests/medal5.png"));
  
  QUEST_HEIGHT = 35; //quest_background -> h;
}

void drawQuests(SDL_Surface* surface, vector<Quest> quests) {
  for (int i = 0; i < (signed)quests.size(); i++) {
    Sint16 base_x = 10;
    Sint16 base_y = (short int)(i * QUEST_HEIGHT) - 10;
    SDL_Rect dest_rect = (SDL_Rect) { base_x, base_y, (Uint16)(RIGHTBAR_WIDTH - 10), (Uint16)(QUEST_HEIGHT - 10) };
            
    /* pozadie */
    //SDL_BlitSurface(quest_background, NULL, surface, &dest_rect);        
    
    /* ikonky a text*/
    char buffer[500];    
    SDL_Surface* text;        
    dest_rect.x = base_x + 45;
    dest_rect.y = base_y + 15;
    SDL_BlitSurface(money_icon, NULL, surface, &dest_rect);

    dest_rect.x = base_x + 80;
    dest_rect.y = base_y + 12;
    sprintf(buffer, "%3d", quests[i].zlato);
    text = TTF_RenderUTF8_Blended(bigfont, buffer, COLOR_YELLOW);    
    SDL_BlitSurface(text, NULL, surface, &dest_rect);
    free(text);
    
    dest_rect.x = base_x + 120;
    dest_rect.y = base_y + 15;
    SDL_BlitSurface(time_icon, NULL, surface, &dest_rect);
    
    dest_rect.x = base_x + 155;
    dest_rect.y = base_y + 12;
    sprintf(buffer, "%3d", quests[i].kedyVznikol);
    text = TTF_RenderUTF8_Blended(bigfont, buffer, COLOR_GREEN);
    SDL_BlitSurface(text, NULL, surface, &dest_rect);
    free(text);    
  }
}
