#include "marshal.h"
#include "common.h"
#include "SDL.h"
#include "SDL_ttf.h"
#include "SDL_image.h"
#include "observer.h"
#include <unistd.h>
#include <time.h>

int getMiliseconds();
int last_time = getMiliseconds();
int waiting_threshold = 1000 /* milisekund */ / FPS;  

/* zisti cas */
int getMiliseconds() {
  struct timespec spec;
  clock_gettime(CLOCK_MONOTONIC, &spec);
  return spec.tv_sec * 1000 + spec.tv_nsec / 1000000;
}

/* pockaj po vykresleni frame-u tak, aby bol zachovany FPS */
void compensateFPS() {
  int previous_time = last_time;
  last_time = getMiliseconds();
  
  int waiting_time = waiting_threshold - (last_time - previous_time);
  
  if (waiting_time > 0)
    usleep(1000 * waiting_time);
  
  last_time = getMiliseconds();
}
