
#ifndef COMMON_H
#define COMMON_H

// vseobecne datove struktury a tak podobne

#include <vector>

#define FOREACH(it,c) for (typeof((c).begin()) it = (c).begin(); it < (c).end(); ++it)
#define ERASE(v,x) (swap((x), *((v).end() - 1)), (v).pop_back())
// TODO: porovnavat "<" je hack, ale FOREACH a ERASE sa inak prilis lahko biju


#define HRDINA_BOJOVNIK    0
#define HRDINA_ZALESAK     1
#define HRDINA_LUMP        2
#define HRDINA_CARODEJ     3
#define HRDINA_KLERIK      4

#define HRDINA_POCET_TYPOV 5

#define ZBRAN_MEC          0
#define ZBRAN_LUK          1
#define ZBRAN_DYKA         2
#define ZBRAN_CARY         3
#define ZBRAN_KLADIVO      4
#define ZBRAN_PAZUR        5
#define ZBRAN_OHEN         6
#define ZBRAN_KYSELINA     7
#define ZBRAN_JED          8

#define ZBRAN_POCET_TYPOV  9

#define OBRANA_POCET_STUPNOV 5

#define NALADA_SPIM   0
#define NALADA_CHODIM 1
#define NALADA_UTOCIM 2


#define PRIKAZ_CHOD 1
#define PRIKAZ_UTOC 2
#define PRIKAZ_POLOZ 3
#define PRIKAZ_VERBUJ 4

struct Prikaz {
  int typ;
  int kto;   // pre "chod" a "poloz" je to id zivocicha, pre "verbuj" typ hrdinu
  int cielX;
  int cielY;
  static Prikaz chod(int id, int cielX, int cielY) {
    return (Prikaz){ PRIKAZ_CHOD, id, cielX, cielY };
  }
  static Prikaz utoc(int id, int cielX, int cielY) {
    return (Prikaz){ PRIKAZ_UTOC, id, cielX, cielY };
  }
  static Prikaz poloz(int id, int cielX, int cielY) {
    return (Prikaz){ PRIKAZ_POLOZ, id, cielX, cielY };
  }
  static Prikaz verbuj(int typHrdinu, int mestoX, int mestoY) {
    return (Prikaz){ PRIKAZ_VERBUJ, typHrdinu, mestoX, mestoY };
  }
};


typedef std::vector<Prikaz> Odpoved;


struct Hrac {
  int zlato;
};


struct Zivocich {
  int id;
  int x;
  int y;
  int ktorehoHraca;    // -1 == potvora
  int typ;             // naraz typ hrdinu aj typ zbrane (u potvor len zbrane)
  int nesenyPredmet;   // -1 == ziaden
  int hp;
  int povodX;
  int povodY;
  std::vector<int> obrana;

  // toto maju vyplnene len potvory (nie hrdinovia)
  int potvoraFaza;
  int potvoraNalada;
};


struct Predmet {
  int x;
  int y;
  int typ;
};


struct Quest {
  int cielX;
  int cielY;
  int ziadanyPredmet;
  int kedyVznikol;
  int zlato;
};


struct Stav {
  std::vector<Hrac> hraci;
  std::vector<Zivocich> zivocichy;
  std::vector<Zivocich> pracovnePonuky;
  std::vector<Predmet> predmety;
  std::vector<Quest> questy;
  int dalsiId;
  int cas;
};


#define MAPA_TEMNE_HORY (-2)
#define MAPA_HORY       (-1)
#define MAPA_VODA       0
#define MAPA_TRAVA      1
#define MAPA_MESTO      2
#define MAPA_TEMNA_ZEM  3

struct Mapa {
  int pocetHracov;
  int w;
  int h;
  std::vector<std::vector<int> > pole;

  int zisti(int x, int y) const {
    return (x >= 0 && x < w && y >= 0 && y < h ? pole[y][x] : MAPA_VODA);
  }
  bool priechodne(int x, int y) const {
    return zisti(x, y) > 0;
  }
};

#define FORMAT_VERSION 1

#endif

#ifdef reflection
// tieto udaje pouziva marshal.cpp aby vedel ako tie struktury ukladat a nacitavat

reflection(Prikaz);
  member(typ);
  member(kto);
  member(cielX);
  member(cielY);
end();

reflection(Hrac);
  member(zlato);
end();

reflection(Zivocich);
  member(id);
  member(x);
  member(y);
  member(ktorehoHraca);
  member(typ);
  member(nesenyPredmet);
  member(hp);
  member(povodX);
  member(povodY);
  member(obrana);
  member(potvoraFaza);
  member(potvoraNalada);
end();

reflection(Predmet);
  member(x);
  member(y);
  member(typ);
end();

reflection(Quest);
  member(cielX);
  member(cielY);
  member(ziadanyPredmet);
  member(kedyVznikol);
  member(zlato);
end();

reflection(Stav);
  member(hraci);
  member(zivocichy);
  member(pracovnePonuky);
  member(predmety);
  member(questy);
  member(cas);
  member(dalsiId);
end();

reflection(Mapa);
  member(pocetHracov);
  member(w);
  member(h);
  member(pole);
end();

#endif
