
#ifndef UPDATE_H
#define UPDATE_H

#include <ostream>
#include <map>

#include "common.h"


extern const int DX[8];
extern const int DY[8];

extern const int kApZasoba;
extern const int kApJedlo;
extern const int kApChod[HRDINA_POCET_TYPOV][9];
extern const int kApUtoc[OBRANA_POCET_STUPNOV][6];
extern const int kApPoloz;
extern const int kApVerbuj;

extern const int kHrdinaObrana[HRDINA_POCET_TYPOV][ZBRAN_POCET_TYPOV];
extern const int kHrdinaHp[HRDINA_POCET_TYPOV];
extern const int kMaximumHrdinovHraca;
extern const int kPeriodaVerbovania;

extern const int kPotvoraDohlad;
extern const int kPotvoraLambdaChodim;
extern const int kPotvoraLambdaUtocim;
extern const int kPotvoraObranaSance[HRDINA_POCET_TYPOV][5];
extern const int kSpawnFaktor;
extern const int kSpawnPokusy;

extern const int kQuestyMaximum;
extern const int kQuestyPeriodaZaklad;
extern const int kQuestyPeriodaFaktor;
extern const int kQuestyVzacne;
extern const int kQuestyPrchavost;

extern const int kOdmenaBezna;
extern const int kOdmenaPrenos;
extern const int kOdmenaNajdi;
extern const int kOdmenaNajdiBonus;
extern const int kOdmenaZnicFaktor;

extern const int kPredmetyBezne;
extern const int kPredmetyVzacne;
extern const int kPredmetyPeriodaZaklad;
extern const int kPredmetyPeriodaFaktor;

extern const int kDlzkaHry;


struct Tah {
  int hrac;   // kto je na tahu
  int ap;
  std::vector<Prikaz> prikazy;
  std::map<int,int> ktoKolkoChodil;
  std::map<int,int> ktoKolkoUtocil;
};


void zapniObservation(std::ostream* observation);

Stav zaciatokHry(const Mapa& mapa);
Tah zaciatokTahu(const Stav& stav, int hrac);
int vzdialenost(int x1, int y1, int x2, int y2);
int zistiApCenu(const Mapa& mapa, const Stav& stav, const Tah& tah, const Prikaz& p);
bool mozeVykonatPrikaz(const Mapa& mapa, const Stav& stav, const Tah& tah, const Prikaz& p);
void zoberPredmet(const Mapa& mapa, Stav& stav, Zivocich& z);
void polozPredmet(const Mapa& mapa, Stav& stav, Zivocich& z, int x, int y);
void zautoc(const Mapa& mapa, Stav& stav, int kto, int ciel);
bool vykonajPrikaz(const Mapa& mapa, Stav& stav, Tah& tah, const Prikaz& p);
bool vykonajPrijatePrikazy(const Mapa& mapa, Stav& stav, int hrac, std::vector<Prikaz>& prikazy);
Prikaz coRobiPotvora(const Mapa& mapa, Stav& stav, const Tah& umelyTah, int id);
int poissonRandom(double lambda);
void tahajPotvorou(const Mapa& mapa, Stav& stav, int id);
int spawnujPotvoru(const Mapa& mapa, Stav& stav, int hrac, int vzacnyPredmet);
int generujPredmet(const Mapa& mapa, Stav& stav, int predmet);
bool generujQuest(const Mapa& mapa, Stav& stav, int hrac);
void vykonajPozadie(const Mapa& mapa, Stav& stav, int hrac);
bool hraSkoncila(const Mapa& mapa, const Stav& stav);
int zistiSkore(const Stav& stav, int hrac);

#endif
